var lyrs = [];
var area = null;
var useHeight = 100;
var maxHeight = 300;
var minHeight = 100;

var range = maxHeight - minHeight;
var mnh = 0;
var mxh = range;

var tanks = [];
var shot = null;
var shooting = false;
var firing = 0;
var explo = null;
var mayFire = true;
var players = 2;

var baseSpeed = [1,-1];
var xSpeed = 8;
var grav = 0.2;
var ySpeed = -5;
var wind = 0.04 - (Math.random() * 0.08);
var boom = [13,28,40,27,13];
var tanklabel = ['blue', 'green'];


simg = [];
simg['up'] = new Image(); simg['up'].src = "images/scup.gif";
simg['dn'] = new Image(); simg['dn'].src = "images/scdn.gif";

function init() {
	useHeight = getRandomHeight(0);
	
	with(area = new dynObject('gameArea')) {
		setProperties(10,10,640,480,'visible','black');
		//write('<img src="images/scorched.jpg"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <img src="images/earth.jpg">')
		clipTo(0,640,480,0);
		setBorder(1, 'solid', 'red')
	}
	
	for(var i=0; i<64; i++) {
		useHeight = getNextHeight(useHeight);
		var useY = 480 - useHeight;
		lyrs[i] = new dynObject('terrain'+i, 'gameArea');
		lyrs[i].setProperties(i*10, useY, 10, useHeight, 'visible', 'brown');		
	}

	drawMountain(0,64);

	buildTank(0, 'blue', 5);
	buildTank(1, 'green', 59);

	shot = new dynObject('tankKillert', 'gameArea');
	shot.setProperties(-10,-10,5,5,'visible','gray');
	shot.clipTo(0,4,4,0);
	
	explo = new dynObject('ploffing', 'gameArea');
	explo.setProperties(-30,-30,21,21,'visible');
	explo.write('<img src="images/explo.gif" align="top">');
	
	arrow = new dynObject('arrow', 'gameArea');
	arrow.setProperties(0,0,10,10,'hidden');
	arrow.write('<img src="images/arrow.gif">')
	
	windiv = new dynObject('wind','gameArea')
	windiv.setProperties(280,80,200,25,'visible');
	windiv.write('weather: a little wind <img src="images/wind'+((wind < 0)?'left':'right')+'.gif">');
	
	targetArea = new dynObject('targetArea', 'gameArea');
	targetArea.setProperties(245,2,150,76,'visible','images/target.gif');
	targetArea.attachEvent('onmousedown', 'moveTargeter()');
	targetArea.css.cursor = 'crosshair'
	
	target = new dynObject('targeter', 'targetArea');
	target.setProperties(73,0,4,4,'hidden','red');
	target.clipTo(0,4,4,0);

	turn = new dynObject('playerturn','targetArea');
	turn.setProperties(65,66,20,10,'visible','images/bluetank.gif');
	turn.clipTo(0,20,10,0)

	if(players == 0) fire();
}

function buildTank(nr, img, pos) {
	tanks[nr] = new dynObject(img+'tankie', 'gameArea');
	tanks[nr].setProperties((pos*10)-(nr*5), lyrs[pos].y-10, 20,10,'visible','images/'+img+'tank.gif');
	tanks[nr].clipTo(0,20,10,0);
	tanks[nr].start = lyrs[pos].y-10;
}

function getNextHeight(lastHeight) {
	var rize = (lastHeight + 1)/range;
	var offset = random(3,4);
	mnh += ((rize > (random(1.3, .7) - Math.random()))? -offset:offset);	
	var newH = lastHeight + Math.round(Math.random() * mnh);
	if(newH < 100) newH = 100;	
	return newH;
}

function getImage(h,dir) {
	return '<img src="'+simg[dir].src+'" width=10 height='+h+' border=0 align="top">'
}

function drawMountain(from, to) {
	var goFrom = from; var goTo = to;
	if(goFrom < 0) goFrom = 0;
	if(goTo > 64) goTo = 64;

	for(var i=goFrom; i<goTo; i++) {
		if(i == 5 || i == 59) continue;
		if(i!=0) {
			var yDif = lyrs[i].y - lyrs[i-1].y
			if(yDif < 0) lyrs[i].write(getImage(Math.abs(yDif), 'up'));
		}
		if(i!=63) {
			var yDif = lyrs[i].y - lyrs[i+1].y
			if(yDif < 0) lyrs[i].write(getImage(Math.abs(yDif), 'dn'));
		}
	}
}

function getRandomHeight() {
	return minHeight + Math.round(Math.random() * range);
}

function random(from, range) {
	return from + (Math.round(Math.random() * range));
}

function fire() {
	if(!mayFire) return;
	mayFire = false;

	if(players != 2) {
		if(players == 1 && firing == 0) {
		} else {
			xSpeed = random(5,5);
			ySpeed = random(-9,5);
			if(firing == 1) xSpeed *= -1;
		}
	}

	if(shooting) clearInterval(shooting);
	shot.moveTo(tanks[firing].x + 10, tanks[firing].y);	
	shooting = setInterval('dummyMover()', 50);	
	firing = (++firing)%2;	
}

	function moveTargeter() {
		if(!mayFire) return;
		target.setVisible(true)
		var nx = mouseX - (area.x + targetArea.x + 4);
		var ny = mouseY - (area.y + 6);

		target.moveTo(nx, ny);
		xSpeed = 0 - ((75 - nx)/6);
		ySpeed = 0 - Math.abs((75 - ny)/6);
		fire()
	}

function dummyMover() {
	shot.moveBy(xSpeed, ySpeed);
	ySpeed += grav;
	xSpeed += wind;
	if(ySpeed > 10) ySpeed = 10;

	if(shot.y < -2) {
		arrow.setVisible(true);
		arrow.moveTo(shot.x, 0)
	} else {
		arrow.setVisible(false);
	}

	overArea = Math.round(shot.x/10);
	if(overArea < 0 || overArea > 63 || shot.y > lyrs[overArea].y) {
		clearInterval(shooting);		
		if(overArea >= 0 && overArea < 64) inpact(overArea);
		turn.setBackground('images/'+tanklabel[firing]+'tank.gif');
		target.setVisible(false);
		
		shot.moveTo(-10,-10);			
		mayFire = true;
		if(players == 0 || (players == firing)) fire();
	}	
}

function inpact(area) {
	explo.moveTo(shot.x, shot.y);
	for(var i=-2; i<3; i++) {
		var pos = i + area;
		if(pos < 0) pos = 0;
		if(pos > 63) pos = 63;
		lyrs[pos].moveBy(0,boom[i+2]);

		if(pos == 5)  tanks[0].moveBy(0,boom[i+2])
		if(pos == 59) tanks[1].moveBy(0,boom[i+2])		
	}

	drawMountain(area-3, area+3);
	for(var i=0; i<2; i++) {
		if(tanks[i].y - tanks[i].start > 100) {
			if(players != 0) alert(tanklabel[i] + ' tank has lost the game.');
			setTimeout('document.location.reload()', 1500);
		}		
	}

	shot.moveTo(-10,-10);
	setTimeout('explo.moveTo(-30,-30)',200);
}